/***************************************************************************
 *            book-fun.h
 *
 *  Fri Sep  2 18:13:22 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomek@paradox.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <gtk/gtk.h>
#include <glib.h>
#include <stdio.h>

struct	BookStruc	{
	gint	id;
	gint	multi_volume;
	
	gchar	title		[64];
	gint	author;
	gint	genere;
	gint	publish_house;	
	
	gchar	isbn		[16];
	gint	publish_year;
	gint	pages;
	
	gchar	description	[2048];
	
	gint	lended;
} book;

struct	MultiVolumeStruc	{
	gint	id;
	
	gchar	title		[64];
	gint	author;
	gint	genere;
	gint	publish_house;
	
	gint	volume_num;
	gint	books_ids	[30];	
	
	gchar	description	[2048];
	
	gint	lended;
} multi_volume;


GtkTreeIter		item_handler;

/*
 *	Zbior funkcji do obslugi pojedynczych ksiazek ma przedrostek 's_'
 */

void			s_load_books_titles					(void);

void			s_select_book_data					(gint	book_id);

void			s_save_book 						(void);

void			s_update_book						(void);

void			s_remove_book						(void);

void			s_display_book_data					(void);
		
void			s_clear_book_display 				(void);

void			s_load_book_dlg_data				(void);

void			s_edit_book_data					(void);

gboolean		s_check_book_data					(void);

void			s_update_book_data					(void);

void			s_reset_book_stuc					(void);

void			s_show_book_info					(gint	id);

/*
 *	Zbior funkcji do obslugi pozycji wielotomowych ma przedrostek 's_'
 */

void			m_load_books_titles					(void);

void			m_select_book_data					(gint	book_id);

void			m_load_single_books_titles			(void);

void			m_add_book_to_books_tview			(void);

void			m_remove_book_from_m_books_tview	(void);

void			m_load_book_dlg_data				(void);

void			m_count_books_in_list				(gint	mode);

gboolean		m_check_book_data					(void);

void			m_update_book_data					(void);

void			m_save_book							(void);

void			m_update_book						(void);

void			m_display_book_data					(void);

void			m_clear_book_display				(void);

void			m_remove_book						(void);

void			m_edit_book							(void);

void			m_reset_multi_volume_struc			(void);
