/***************************************************************************
 *            lists-fun.c
 *
 *  Sun Aug 21 09:25:13 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomek@paradox.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <glade/glade.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <stdio.h>

#include "lists-fun.h"
#include "support.h"
#include "interface.h"

#define	DEVELOPMENT_GUI_FILE "/home/tomek/Projekty/Libglade-GBiblioteka/gbiblioteka.glade"

/*
 *	Funkcja tworzy prototyp listy 'main_view'
 */
 
void create_single_volume_view (void)	{
	GtkListStore 		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*widget;
	
	widget = glade_xml_get_widget (main_win_xml, "single_volume_tview");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Book ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (widget), GTK_TREE_MODEL(store));
}

void create_multi_volume_view (void)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*widget;
	
	widget = glade_xml_get_widget (main_win_xml, "multi_volume_tview");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Book ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (widget), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja tworzy liste w oknie 'search_tool_dlg'
 */

void	create_search_tool_view		(void)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*widget;
	
	widget = glade_xml_get_widget (search_tool_xml, "search_result_tview");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Book ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (widget), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja tworzy modele list w trzech oknach. Ustala sie ja za pomoca zmiennej
 *	'mode':
 *		- 0 - odpowiada za liste w oknie 'main_win'
 *		- 1 - odpowiada za liste w oknie 'multi_volume_dlg'
 *		- 2 - odpowiada za liste w oknie 'm_volume_add_book_dlg'
 */

void	create_m_books_view			(gint mode)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*widget;
	
	switch (mode)	{
		case 0:
			widget = glade_xml_get_widget (main_win_xml, "m_books_tview");
			break;
		case 1:
			widget = glade_xml_get_widget (multi_volume_xml, "m_books_tview");
			break;
		case 2:
			widget = glade_xml_get_widget (select_m_books_xml, "single_books_tview");
			break;
	}
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Book ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (widget), GTK_TREE_MODEL(store));
}

void create_menage_data_view (gint	mode)	{
	GtkListStore 		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*widget;
	
	switch (mode)	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_tview");
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_tview");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_tview");
			break;
	}
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	switch (mode)	{
		case 0:
			gtk_tree_view_column_pack_start(column, renderer, TRUE);
			gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
			gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
			gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
			gtk_tree_view_column_set_title (column, _("Author"));
			break;
		case 1:
			gtk_tree_view_column_pack_start(column, renderer, TRUE);
			gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
			gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
			gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
			gtk_tree_view_column_set_title (column, _("Genere"));
			break;
		case 2:
			gtk_tree_view_column_pack_start(column, renderer, TRUE);
			gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
			gtk_tree_view_append_column(GTK_TREE_VIEW (widget), column);
			gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
			gtk_tree_view_column_set_title (column, _("Publish house"));
			break;
	}
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (widget), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja usuwa wszystkie wiersze z pojedynczej listy wskazanej przez
 *	argument 'tree_view'
 */

void	clear_list_view		(GtkTreeView	*tree_view)		{
	GtkTreeModel	*model;
	
	model = gtk_tree_view_get_model (tree_view);
	
	gtk_list_store_clear (GTK_LIST_STORE (model));
}
