/***************************************************************************
 *            main.c
 *
 *  Mon Aug 22 10:11:06 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomek@paradox.pl
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "db-fun.h"
#include "book-fun.h"
#include "main-callbacks.h"
#include "other-callbacks.h"

int
main (int argc, char *argv[])
{
	GtkWidget	*main_win;
	gboolean	status;

#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif
	
	gtk_set_locale ();
	gtk_init (&argc, &argv);

	/*
	 * The following code was added by Glade to create one of each component
     * (except popup menus), just so that you see something after building
  	 * the project. Delete any components that you don't want shown initially.
     */
	
	status = load_gui_xml ();
	
	if (status)	{
		main_win = create_main_win ();
		
		/*status = load_settings_file ();
		
		if (status)	{
		
		}*/
		gtk_widget_show (main_win);
		
		status = check_db_exist ();
	
		set_statusbar_text (_("Opening database..."));
		if (status)	{
			open_db ();
			s_load_books_titles ();
			m_load_books_titles ();
			set_statusbar_text (_("Gbiblioteka is ready to work."));
		}
		else	{
			set_statusbar_text (_("No database file, creating base files, please wait..."));
			first_run ();
			
			status = check_db_exist ();
			if (status)	{
				open_db ();
				set_statusbar_text (_("Gbiblioteka is ready to work."));
			}
			else	{
				set_statusbar_text (_("Error, GBiblioteka can't open database!"));
			}
		}
		
		gtk_main ();
	}

	return 0;
}
