/***************************************************************************
 *            other-callbacks.c
 *
 *  Mon Aug 29 14:16:04 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomek@paradox.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <glade/glade.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <stdio.h>

#include "other-callbacks.h"
#include "interface.h"
#include "book-fun.h"
#include "lists-fun.h"
#include "support.h"
#include "search-fun.h"
#include "other_data-fun.h"


void
on_settings_cancel_but_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	widget = glade_xml_get_widget (settings_xml, "settings_dlg");
	gtk_widget_destroy (widget);
	settings_xml = NULL;
}


void
on_settings_ok_but_clicked             (GtkButton       *button,
                                        gpointer         user_data)
										
{
	GtkWidget	*widget;
	
	widget = glade_xml_get_widget (settings_xml, "settings_dlg");
	gtk_widget_destroy (widget);
	settings_xml = NULL;;
}

gboolean
on_settings_dlg_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_widget_destroy (widget);
	settings_xml = NULL;;
	return FALSE;
}
/*
 *	Funkcje zwrotne okna 'single_book_dlg'
 */

void
on_single_book_save_but_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	result;
	
	result = s_check_book_data ();
	if (result == TRUE)	{
		GtkWidget	*widget;
		widget = glade_xml_get_widget (single_book_xml, "single_book_dlg");
		s_update_book_data ();
		s_save_book ();
		gtk_widget_destroy (widget);
		single_book_xml = NULL;
		
		widget = glade_xml_get_widget (main_win_xml, "single_volume_tview");
		clear_list_view (GTK_TREE_VIEW (widget));
		s_load_books_titles ();
		s_reset_book_stuc ();
	}
}

void
on_single_book_update_but_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	result;
	
	result = s_check_book_data ();
	if (result == TRUE)	{
		GtkWidget	*widget;
		widget = glade_xml_get_widget (single_book_xml, "single_book_dlg");
		s_update_book_data ();
		s_update_book ();
		gtk_widget_destroy (widget);
		single_book_xml = NULL;
		
		widget = glade_xml_get_widget (main_win_xml, "single_volume_tview");
		clear_list_view (GTK_TREE_VIEW (widget));
		s_load_books_titles ();
		
		s_clear_book_display ();
		s_reset_book_stuc ();
	}
}

void
on_single_book_cancel_but_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	status;
	status = show_question_dlg (_("Close this window?"),
								_("If you press \"Yes\", you will lose all "
								"changed informations about book(s), do you "
								"really want to continue?"));
	if (status == TRUE)	{
		GtkWidget	*widget;
		widget = glade_xml_get_widget (single_book_xml, "single_book_dlg");
		gtk_widget_destroy (widget);
		single_book_xml = NULL;
	}
}

gboolean
on_single_book_dlg_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gboolean	status;
	status = show_question_dlg (_("Close this window?"),
								_("If you press \"Yes\", you will lose all "
								"changed informations about book(s), do you "
								"really want to continue?"));
	if (status == TRUE)	{
		GtkWidget	*dialog;
		dialog = glade_xml_get_widget (single_book_xml, "single_book_dlg");
		gtk_widget_destroy (dialog);
		single_book_xml = NULL;
		
		return FALSE;
	}
	else	{
		return TRUE;
	}
}

/*
 *	Funkcje zwrotne okna 'menage_data_dlg'
 */

void
on_menage_data_close_but_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_dlg");
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_dlg");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_dlg");
			break;
	}
		
	gtk_widget_destroy (widget);
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			menage_authors_data_xml = NULL;
			break;
		case 1:
			menage_generes_data_xml = NULL;
			break;
		case 2:
			menage_pub_houses_data_xml = NULL;
			break;
	}
}

gboolean
on_menage_data_dlg_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_widget_destroy (widget);
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			menage_authors_data_xml = NULL;
			break;
		case 1:
			menage_generes_data_xml = NULL;
			break;
		case 2:
			menage_pub_houses_data_xml = NULL;
			break;
	}
	return FALSE;
};

void
on_menage_data_tview_cursor_changed    (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
	GtkTreeSelection	*selection;
	GtkTreeModel		*model;
  	GtkTreeIter			iter;
	GtkWidget			*widget;
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	gtk_tree_selection_get_selected(selection, &model, &iter);
	
	gtk_tree_model_get (model, &iter, 0, &selected_data_id, -1);
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			set_widget_sensinitive (menage_authors_data_xml, "menage_data_add_but", FALSE);
			set_widget_sensinitive (menage_authors_data_xml, "menage_data_remove_but", TRUE);
			break;
		case 1:
			set_widget_sensinitive (menage_generes_data_xml, "menage_data_add_but", FALSE);
			set_widget_sensinitive (menage_generes_data_xml, "menage_data_remove_but", TRUE);
			break;
		case 2:
			set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_add_but", FALSE);
			set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_remove_but", TRUE);
			break;
	}
}


void
on_menage_data_en_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	if (strlen (gtk_entry_get_text (GTK_ENTRY (editable))) == 0)	{
		switch (GPOINTER_TO_INT (user_data))	{
			case 0:
				set_widget_sensinitive (menage_authors_data_xml, "menage_data_add_but", FALSE);
				break;
			case 1:
				set_widget_sensinitive (menage_generes_data_xml, "menage_data_add_but", FALSE);
				break;
			case 2:
				set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_add_but", FALSE);
				break;
		}
	}
	else	{
		switch (GPOINTER_TO_INT (user_data))	{
			case 0:
				set_widget_sensinitive (menage_authors_data_xml, "menage_data_add_but", TRUE);
				break;
			case 1:
				set_widget_sensinitive (menage_generes_data_xml, "menage_data_add_but", TRUE);
				break;
			case 2:
				set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_add_but", TRUE);
				break;
		}
	}
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			set_widget_sensinitive (menage_authors_data_xml, "menage_data_remove_but", FALSE);
			break;
		case 1:
			set_widget_sensinitive (menage_generes_data_xml, "menage_data_remove_but", FALSE);
			break;
		case 2:
			set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_remove_but", FALSE);
			break;
	}
}


void
on_menage_data_add_but_clicked         (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget		*widget;
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_en");
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_en");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_en");
			break;
	}
	
	add_item_to_database (widget, GPOINTER_TO_INT (user_data));
	gtk_entry_set_text (GTK_ENTRY (widget), "");
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_tview");;
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_tview");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_tview");;
			break;
	}
	clear_list_view (GTK_TREE_VIEW (widget));
	
	load_data (GPOINTER_TO_INT (user_data));
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			set_widget_sensinitive (menage_authors_data_xml, "menage_data_add_but", FALSE);
			break;
		case 1:
			set_widget_sensinitive (menage_generes_data_xml, "menage_data_add_but", FALSE);
			break;
		case 2:
			set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_add_but", FALSE);
			break;
	}
}


void
on_menage_data_remove_but_clicked      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget		*widget;
	
	check_if_item_is_used (GPOINTER_TO_INT (user_data), selected_data_id);
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_en");
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_en");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_en");
			break;
	}
	gtk_entry_set_text (GTK_ENTRY (widget), "");
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			widget = glade_xml_get_widget (menage_authors_data_xml, "menage_data_tview");;
			break;
		case 1:
			widget = glade_xml_get_widget (menage_generes_data_xml, "menage_data_tview");
			break;
		case 2:
			widget = glade_xml_get_widget (menage_pub_houses_data_xml, "menage_data_tview");;
			break;
	}
	clear_list_view (GTK_TREE_VIEW (widget));
	
	load_data (GPOINTER_TO_INT (user_data));
	
	switch (GPOINTER_TO_INT (user_data))	{
		case 0:
			set_widget_sensinitive (menage_authors_data_xml, "menage_data_remove_but", FALSE);
			break;
		case 1:
			set_widget_sensinitive (menage_generes_data_xml, "menage_data_remove_but", FALSE);
			break;
		case 2:
			set_widget_sensinitive (menage_pub_houses_data_xml, "menage_data_remove_but", FALSE);
			break;
	}
}

/*
 *	Funkcje zwrotne dla okna 'search_tool_dlg'
 */

void
on_search_run_but_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	search_check_data ();
	widget = glade_xml_get_widget (search_tool_xml, "search_result_tview");
	clear_list_view (GTK_TREE_VIEW (widget));
	search_books ();
}

void
on_search_stop_but_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	widget = glade_xml_get_widget (search_tool_xml, "search_tool_dlg");
	gtk_widget_destroy (widget);
	search_tool_xml = NULL;
}


void
on_search_close_but_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	widget = glade_xml_get_widget (search_tool_xml, "search_tool_dlg");
	gtk_widget_destroy (widget);
	search_tool_xml = NULL;
}

gboolean
on_search_tool_dlg_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_widget_destroy (widget);
	search_tool_xml = NULL;
	return FALSE;
}

void
on_search_title_en_activate            (GtkEntry        *entry,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	search_check_data ();
	widget = glade_xml_get_widget (search_tool_xml, "search_result_tview");
	clear_list_view (GTK_TREE_VIEW (widget));
	search_books ();
}

void
on_search_result_tview_row_activated   (GtkTreeView     *treeview,
                                        GtkTreePath     *path,
                                        GtkTreeViewColumn *column,
                                        gpointer         user_data)
{
	GtkTreeSelection	*selection;
	GtkTreeModel		*model;
  	GtkTreeIter			iter;
	GtkWidget			*widget;
	gint				book_id;
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	gtk_tree_selection_get_selected(selection, &model, &iter);
	
	gtk_tree_model_get (model, &iter, 0, &book_id, -1);
	
	if ( !check_if_dialog_exist (display_book_info_xml))	{
		/* Jezeli okno juz istnieje to nie tworzymy nowego, wykorzystamy juz 
		   istniejace*/
		widget = create_display_book_info_dlg ();
		gtk_widget_show (widget);
	}
	s_show_book_info (book_id);
}

/*
 *	Funkcje zwrotne dla okna 'm_volume_dlg'
 */

void
on_m_books_tview_cursor_changed        (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
	set_widget_sensinitive (multi_volume_xml, "m_remove_book_but", TRUE);
}


void
on_m_add_book_but_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	widget = create_select_m_books_dlg ();
	create_m_books_view (2);
	m_load_single_books_titles ();
	gtk_dialog_run (GTK_DIALOG (widget));
}


void
on_m_remove_book_but_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	m_remove_book_from_m_books_tview ();
	m_count_books_in_list (0);
}


void
on_m_volume_cancel_but_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	status;
	status = show_question_dlg (_("Close this window?"),
								_("If you press \"Yes\", you will lose all "
								"changed informations about book(s), do you "
								"really want to continue?"));
	if (status == TRUE)	{
		GtkWidget	*dialog;
		dialog = glade_xml_get_widget (multi_volume_xml, "multi_volume_dlg");
		gtk_widget_destroy (dialog);
		multi_volume_xml = NULL;
		
		clear_tmp_fields ();
	}
}


void
on_m_volume_save_but_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	result;
	
	result = m_check_book_data ();
	if (result == TRUE)	{
		GtkWidget	*widget;
		widget = glade_xml_get_widget (multi_volume_xml, "multi_volume_dlg");
		m_update_book_data ();
		m_save_book ();
		gtk_widget_destroy (widget);
		multi_volume_xml = NULL;
		
		widget = glade_xml_get_widget (main_win_xml, "multi_volume_tview");
		clear_list_view (GTK_TREE_VIEW (widget));
		m_load_books_titles ();
		
		clear_tmp_fields ();
		m_reset_multi_volume_struc ();
	}
}


void
on_m_volume_update_but_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	gboolean	result;
	
	result = m_check_book_data ();
	if (result == TRUE)	{
		GtkWidget	*widget;
		widget = glade_xml_get_widget (multi_volume_xml, "multi_volume_dlg");
		m_update_book_data ();
		m_update_book ();
		gtk_widget_destroy (widget);
		multi_volume_xml = NULL;
		
		widget = glade_xml_get_widget (main_win_xml, "multi_volume_tview");
		clear_list_view (GTK_TREE_VIEW (widget));
		m_load_books_titles ();
		
		clear_tmp_fields ();
		m_reset_multi_volume_struc ();
	}
}

gboolean
on_multi_volume_dlg_delete_event       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gboolean	status;
	status = show_question_dlg (_("Close this window?"),
								_("If you press \"Yes\", you will lose all "
								"changed informations about book(s), do you "
								"really want to continue?"));
	if (status == TRUE)	{
		GtkWidget	*dialog;
		dialog = glade_xml_get_widget (multi_volume_xml, "multi_volume_dlg");
		gtk_widget_destroy (dialog);
		multi_volume_xml = NULL;
		
		clear_tmp_fields ();
		
		return FALSE;
	}
	else	{
		return TRUE;
	}
}

void
on_single_books_tview_cursor_changed   (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
	set_widget_sensinitive (select_m_books_xml, "select_m_books_add_but", TRUE);
}


void
on_select_m_books_add_but_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	m_add_book_to_books_tview ();
	m_count_books_in_list (1);
	
	widget = glade_xml_get_widget (select_m_books_xml, "select_m_books_dlg");
	gtk_widget_destroy (widget);
	select_m_books_xml = NULL;
}


void
on_select_m_books_cancel_but_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	widget = glade_xml_get_widget (select_m_books_xml, "select_m_books_dlg");
	gtk_widget_destroy (widget);
	select_m_books_xml = NULL;
}

gboolean
on_select_m_books_dlg_delete_event     (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_widget_destroy (widget);
	select_m_books_xml = NULL;
	return FALSE;
}

void
on_single_books_tview_row_activated    (GtkTreeView     *treeview,
                                        GtkTreePath     *path,
                                        GtkTreeViewColumn *column,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	
	m_add_book_to_books_tview ();
	m_count_books_in_list (1);
	
	widget = glade_xml_get_widget (select_m_books_xml, "select_m_books_dlg");
	gtk_widget_destroy (widget);
	select_m_books_xml = NULL;
}

/*
 *	Funkcje zwrotne okna 'display_book_info_dlg'
 */

gboolean
on_display_book_info_dlg_delete_event  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_widget_destroy (widget);
	display_book_info_xml = NULL;
	return FALSE;
}

void
on_display_book_info_close_but_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*widget;
	widget = glade_xml_get_widget (display_book_info_xml, "display_book_info_dlg");
	gtk_widget_destroy (widget);
	display_book_info_xml = NULL;
}
