/***************************************************************************
 *            search-fun.c
 *
 *  Fri Oct  7 12:57:54 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomek@paradox.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <sqlite3.h>
#include <glade/glade.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <stdio.h>

#include "search-fun.h"
#include "db-fun.h"
#include "book-fun.h"
#include "support.h"
#include "interface.h"


/*
 *	Funkcja sprawdza, czy dane wprowadzone do pol okna 'search_tool_dlg'
 *	sa poprawne.
 */
 
 
gboolean	search_check_data	(void)	{
	GtkWidget	*tmp;
	
	tmp = glade_xml_get_widget (search_tool_xml, "search_title_en");
	if (strlen (gtk_entry_get_text (GTK_ENTRY (tmp))) == 0)	{
		show_message_dlg (_("Wrong data"), _("Field \'Title\' can't be empty!"), 1);
		return FALSE;
	}
	return TRUE;
}

/*
 *	Funkcja wyszukuje ksiazki w bazie danych po tytule.
 *	
 *	To tylko tymczasowa funkcja i zostanie usunieta wraz z rozwojem funkcji 
 *	wyszukujacych GBibliotei.
 */

void		search_books		(void)	{
	GtkListStore		*store;
	GtkTreeIter			iter;
	GtkWidget			*tmp;
	sqlite3_stmt		*db_row;
	gchar				sql_query	[1024];
	gint				status;
	gint				rows;
	
	tmp = glade_xml_get_widget (search_tool_xml, "search_title_en");
	
	g_sprintf (sql_query, "SELECT id, title FROM books WHERE title LIKE \"%s%s%s\";",
			   "%", gtk_entry_get_text (GTK_ENTRY (tmp)), "%");
	
	rows = count_returned_rows (sql_query);
	
	sqlite3_prepare(db_handler, sql_query, -1, &db_row, 0);
	status = sqlite3_step (db_row);
	g_printf ("<<< Searching books, SQLite result: %d\n", status);
	
	tmp = glade_xml_get_widget (search_tool_xml, "search_result_tview");
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (tmp));
	
	if (rows > 0)	{
		while (status == 100)		{
			gtk_list_store_append (GTK_LIST_STORE (store), &iter);
			gtk_list_store_set (GTK_LIST_STORE (store), &iter,
								0, sqlite3_column_int (db_row, 0), 
								1, sqlite3_column_text (db_row, 1),
								-1);
			
			status = sqlite3_step (db_row);
		}
		g_printf ("\t<<< Got last book, SQLite result: %d\n", status);
	}
	
	sqlite3_finalize (db_row);
}
